=== debian/changelog ===
liblsl (1.16.2b1-1) experimental; urgency=medium

  * Initial release (Closes: #1032996)

 -- Enrico Zini <enrico@debian.org>  Thu, 23 Mar 2023 10:34:07 +0100
