=== debian/control ===
Source: liblsl
Section: libs
Priority: optional
Maintainer: Enrico Zini <enrico@debian.org>
Build-Depends: 
 debhelper-compat (= 13), cmake,
 libboost1.74-dev, catch2, libasio-dev, libpugixml-dev
Standards-Version: 4.6.0
Homepage: https://github.com/sccn/liblsl
Vcs-Browser: https://salsa.debian.org/science-team/liblsl
Vcs-Git: https://salsa.debian.org/science-team/liblsl.git

Package: liblsl1
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: library for multi-modal time-synched data transmission over the local network
 The lab streaming layer is a simple all-in-one approach to streaming
 experiment data between applications in a lab, e.g. instrument time series,
 event markers, audio, and so on

Package: liblsl-dev
Section: libdevel
Architecture: any
Depends: liblsl1 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: library for multi-modal time-synched data transmission over the local network (devel)
 The lab streaming layer is a simple all-in-one approach to streaming
 experiment data between applications in a lab, e.g. instrument time series,
 event markers, audio, and so on
 .
 This package contains the development library
