=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
include /usr/share/dpkg/buildflags.mk

%:
	dh $@ --without autoreconf -S cmake

override_dh_auto_configure:
	dh_auto_configure -- -DLSL_BUNDLED_BOOST=OFF -DLSL_BUNDLED_PUGIXML=OFF -DLSL_UNITTESTS=ON

execute_after_dh_auto_test:
	obj-$(DEB_HOST_GNU_TYPE)/testing/lsl_test_internal
